"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.when = when;
var every = exports.every = function every(conditions) {
  return function (facts) {
    return conditions.every(function (condition) {
      return condition(facts);
    });
  };
};
var some = exports.some = function some(conditions) {
  return function (facts) {
    return conditions.some(function (condition) {
      return condition(facts);
    });
  };
};
var notEvery = exports.notEvery = function notEvery(conditions) {
  return function (facts) {
    return !every(conditions)(facts);
  };
};
var notSome = exports.notSome = function notSome(conditions) {
  return function (facts) {
    return !some(conditions)(facts);
  };
};

function when(result) {
  var reactions = {
    do: function _do(fn) {
      if (result) fn(result);
      return reactions;
    },
    else: function _else(fn) {
      if (!result) fn(result);
      return reactions;
    }
  };
  return reactions;
}